from __future__ import annotations
from typing import Any
from enum import IntEnum
from enum import auto

class AnimationEffect(IntEnum):
    NONE = auto()
    FADE_FROM_LEFT = auto()
    FADE_FROM_TOP = auto()
    FADE_FROM_RIGHT = auto()
    FADE_FROM_BOTTOM = auto()
    FADE_TO_CENTER = auto()
    FADE_FROM_CENTER = auto()
    MOVE_FROM_LEFT = auto()
    MOVE_FROM_TOP = auto()
    MOVE_FROM_RIGHT = auto()
    MOVE_FROM_BOTTOM = auto()
    VERTICAL_STRIPES = auto()
    HORIZONTAL_STRIPES = auto()
    CLOCKWISE = auto()
    COUNTERCLOCKWISE = auto()
    FADE_FROM_UPPERLEFT = auto()
    FADE_FROM_UPPERRIGHT = auto()
    FADE_FROM_LOWERLEFT = auto()
    FADE_FROM_LOWERRIGHT = auto()
    CLOSE_VERTICAL = auto()
    CLOSE_HORIZONTAL = auto()
    OPEN_VERTICAL = auto()
    OPEN_HORIZONTAL = auto()
    PATH = auto()
    MOVE_TO_LEFT = auto()
    MOVE_TO_TOP = auto()
    MOVE_TO_RIGHT = auto()
    MOVE_TO_BOTTOM = auto()
    SPIRALIN_LEFT = auto()
    SPIRALIN_RIGHT = auto()
    SPIRALOUT_LEFT = auto()
    SPIRALOUT_RIGHT = auto()
    DISSOLVE = auto()
    WAVYLINE_FROM_LEFT = auto()
    WAVYLINE_FROM_TOP = auto()
    WAVYLINE_FROM_RIGHT = auto()
    WAVYLINE_FROM_BOTTOM = auto()
    RANDOM = auto()
    VERTICAL_LINES = auto()
    HORIZONTAL_LINES = auto()
    LASER_FROM_LEFT = auto()
    LASER_FROM_TOP = auto()
    LASER_FROM_RIGHT = auto()
    LASER_FROM_BOTTOM = auto()
    LASER_FROM_UPPERLEFT = auto()
    LASER_FROM_UPPERRIGHT = auto()
    LASER_FROM_LOWERLEFT = auto()
    LASER_FROM_LOWERRIGHT = auto()
    APPEAR = auto()
    HIDE = auto()
    MOVE_FROM_UPPERLEFT = auto()
    MOVE_FROM_UPPERRIGHT = auto()
    MOVE_FROM_LOWERRIGHT = auto()
    MOVE_FROM_LOWERLEFT = auto()
    MOVE_TO_UPPERLEFT = auto()
    MOVE_TO_UPPERRIGHT = auto()
    MOVE_TO_LOWERRIGHT = auto()
    MOVE_TO_LOWERLEFT = auto()
    MOVE_SHORT_FROM_LEFT = auto()
    MOVE_SHORT_FROM_UPPERLEFT = auto()
    MOVE_SHORT_FROM_TOP = auto()
    MOVE_SHORT_FROM_UPPERRIGHT = auto()
    MOVE_SHORT_FROM_RIGHT = auto()
    MOVE_SHORT_FROM_LOWERRIGHT = auto()
    MOVE_SHORT_FROM_BOTTOM = auto()
    MOVE_SHORT_FROM_LOWERLEFT = auto()
    MOVE_SHORT_TO_LEFT = auto()
    MOVE_SHORT_TO_UPPERLEFT = auto()
    MOVE_SHORT_TO_TOP = auto()
    MOVE_SHORT_TO_UPPERRIGHT = auto()
    MOVE_SHORT_TO_RIGHT = auto()
    MOVE_SHORT_TO_LOWERRIGHT = auto()
    MOVE_SHORT_TO_BOTTOM = auto()
    MOVE_SHORT_TO_LOWERLEFT = auto()
    VERTICAL_CHECKERBOARD = auto()
    HORIZONTAL_CHECKERBOARD = auto()
    HORIZONTAL_ROTATE = auto()
    VERTICAL_ROTATE = auto()
    HORIZONTAL_STRETCH = auto()
    VERTICAL_STRETCH = auto()
    STRETCH_FROM_LEFT = auto()
    STRETCH_FROM_UPPERLEFT = auto()
    STRETCH_FROM_TOP = auto()
    STRETCH_FROM_UPPERRIGHT = auto()
    STRETCH_FROM_RIGHT = auto()
    STRETCH_FROM_LOWERRIGHT = auto()
    STRETCH_FROM_BOTTOM = auto()
    STRETCH_FROM_LOWERLEFT = auto()
    ZOOM_IN = auto()
    ZOOM_IN_SMALL = auto()
    ZOOM_IN_SPIRAL = auto()
    ZOOM_OUT = auto()
    ZOOM_OUT_SMALL = auto()
    ZOOM_OUT_SPIRAL = auto()
    ZOOM_IN_FROM_LEFT = auto()
    ZOOM_IN_FROM_UPPERLEFT = auto()
    ZOOM_IN_FROM_TOP = auto()
    ZOOM_IN_FROM_UPPERRIGHT = auto()
    ZOOM_IN_FROM_RIGHT = auto()
    ZOOM_IN_FROM_LOWERRIGHT = auto()
    ZOOM_IN_FROM_BOTTOM = auto()
    ZOOM_IN_FROM_LOWERLEFT = auto()
    ZOOM_IN_FROM_CENTER = auto()
    ZOOM_OUT_FROM_LEFT = auto()
    ZOOM_OUT_FROM_UPPERLEFT = auto()
    ZOOM_OUT_FROM_TOP = auto()
    ZOOM_OUT_FROM_UPPERRIGHT = auto()
    ZOOM_OUT_FROM_RIGHT = auto()
    ZOOM_OUT_FROM_LOWERRIGHT = auto()
    ZOOM_OUT_FROM_BOTTOM = auto()
    ZOOM_OUT_FROM_LOWERLEFT = auto()
    ZOOM_OUT_FROM_CENTER = auto()
